#include <avr/io.h>

#define uart_init(br) do {			\
	UCSRC = _BV(UCSZ1) | _BV(UCSZ0);	\
	UBRRH = 0;				\
	UBRRL = F_CPU / (br * 16) - 1;		\
	UCSRB = _BV(RXEN) | _BV(TXEN);		\
} while (0)

#define uart_read_ready() (UCSRA & _BV(RXC))
#define uart_write_ready() (UCSRA & _BV(UDRE))

#define uart_read() ({				\
	loop_until_bit_is_set(UCSRA, RXC)	\
		;				\
	UDR;					\
})

#define uart_write(ch) do {			\
	loop_until_bit_is_set(UCSRA, UDRE)	\
		;				\
	UDR = ch;				\
} while (0)
